#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_ext
from pythonite.objects.file_obj import File
import wave

class Wave(File):
    objtype = 'audio'
    wavefile = None
    def waveattr(self, attr):
        if self.wavefile == None:
            self.wavefile = wave.open(self.path)
        return getattr(self.wavefile, 'get'+attr)()
    def get_title(self):
        return ''
    def get_album(self):
        return ''
    def get_artist(self):
        return ''
    def get_year(self):
        return ''
    def get_track(self):
	return ''
    def get_duration(self):
        n = self.waveattr('nframes')
        f = self.waveattr('framerate')
        t = n/f
	m, s = divmod(t, 60)
	h, m = divmod(m, 60)
	return '%d:%02d:%02d' % (h, m, s)
    def get_bitrate(self):
        n = self.waveattr('nchannels')
        w = self.waveattr('sampwidth')
        f = self.waveattr('framerate')
        b = n*w*8*f
	return '%.0f Kbit/s' % (b/1000.)
    def get_samplerate(self):
        k = self.waveattr('framerate')
	return '%.1f KHz' % (k/1000.)
    def get_bits(self):
        return self.waveattr('sampwidth')*8
    def get_channels(self):
        return self.waveattr('nchannels')
    def get_codec(self):
        return ''

register_ext('.wav', Wave)
